﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace UserManagement
{
    public class User
    {
        private string firstName;
        private string lastName;
        private DateTime dateOfBirth;
        private string department;
        public static readonly List<string> ValidDepartments = new List<string> { "Dev", "QA", "Management","Finance"};

        public string FirstName 
        {
            get { return firstName; }
            set
            {
                if (value == null || value == String.Empty)
                {
                    throw new ArgumentNullException();
                }
                firstName = value;
            }
        }

        public string LastName
        {
            get { return lastName; }
            set
            {
                if (value == null || value == String.Empty)
                {
                    throw new ArgumentNullException();
                }
                lastName = value;
            }
        }

        public DateTime DateOfBirth
        {
            get { return dateOfBirth; }
            set
            {
                if (value >= DateTime.Now)
                {
                    throw new ArgumentOutOfRangeException();
                }

                dateOfBirth = value;
            }
        }

        public string Department
        {
            get { return department; }
            set 
            {
                if (!ValidDepartments.Contains(value))
                {
                    throw new ArgumentOutOfRangeException("Not a valid department");
                }
                department = value; 
            }
        }
    }
}
