﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace UserManagement
{
    public class UserController
    {
        User model;
        IDataAccess dataAccess;

        public UserController(IUserView view, IDataAccess dataAccess)
        {
            model = new User();
            this.dataAccess = dataAccess;
            view.FieldEntered += new FieldEnteredDelegate(view_FieldEntered);
            view.UserSubmitted += new UserSubmittedDelegate(view_UserSubmitted);
        }

        void view_UserSubmitted(IUserView view)
        {
            dataAccess.SaveModel(model);
        }

        void view_FieldEntered(IUserView sender, string fieldName)
        {
            try
            {
                switch (fieldName)
                {
                    case "FirstName":
                        model.FirstName = sender.FirstName;
                        break;
                    case "LastName":
                        model.LastName = sender.LastName;
                        break;
                    case "DateOfBirth":
                        model.DateOfBirth = sender.DateOfBirth;
                        break;
                    case "Department":
                        model.Department = sender.Department;
                        break;
                    default:
                        throw new ArgumentException("Unknown Field Name");
                }
            }
            catch (ArgumentException ex)
            {
                sender.InvalidField(fieldName, ex.Message);
            }
        }
    }
}
