﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UserManagement;

namespace UserManagementCLI
{
    class Program : IUserView
    {

        static void Main(string[] args)
        {
            Program p = new Program();
            UserController uc = new UserController(p, new DataAccess());
            p.ManageUser();
        }

        private bool fieldWasValid = false;
        private string firstName = null;
        private string lastName = null;
        private DateTime dateOfBirth = DateTime.MaxValue;
        private string department = null;

        public void ManageUser()
        {
            GetFirstName();
            GetLastName();
            GetDateOfBirth();
            GetDepartment();

            Console.Write("Save User? (Y or N) ");
            if (Console.ReadLine() == "Y")
                UserSubmitted(this);

            Console.WriteLine("All Done");
            Console.ReadLine();
        }

        private void GetFirstName()
        {
            fieldWasValid = false;

            while (!fieldWasValid)
            {
                fieldWasValid = true;
                Console.Write("Enter First Name: ");
                firstName = Console.ReadLine();
                FieldEntered(this, "FirstName");
            }
        }

        private void GetLastName()
        {
            fieldWasValid = false;

            while (!fieldWasValid)
            {
                fieldWasValid = true;
                Console.Write("Enter Last Name: ");
                lastName = Console.ReadLine();
                FieldEntered(this, "LastName");
            }
        }

        private void GetDateOfBirth()
        {
            fieldWasValid = false;

            while (!fieldWasValid)
            {
                fieldWasValid = true;
                Console.Write("Enter Date Of Birth: ");
                string dob = Console.ReadLine();
                if (!DateTime.TryParse(dob, out dateOfBirth))
                {
                    fieldWasValid = false;
                }
                else
                {
                    FieldEntered(this, "DateOfBirth");
                }

            }
        }

        private void GetDepartment()
        {
            fieldWasValid = false;

            while (!fieldWasValid)
            {
                fieldWasValid = true;
                Console.Write("Enter Department: ");
                department = Console.ReadLine();
                FieldEntered(this, "Department");
            }
        }

        #region IUserView Members

        public event FieldEnteredDelegate FieldEntered;
        public event UserSubmittedDelegate UserSubmitted;

        public void InvalidField(string fieldName, string message)
        {
            Console.WriteLine("INVALID FIELD: " + fieldName);
            fieldWasValid = false;
        }

        public string FirstName
        {
            get { return firstName; }
        }

        public string LastName
        {
            get { return lastName; }
        }

        public DateTime DateOfBirth
        {
            get { return dateOfBirth; }
        }

        public string Department
        {
            get { return department; }
        }

        #endregion
    }
}
